import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as de, useState as K, useMemo as d, useEffect as ce, useRef as z, useCallback as je } from "react";
import { isMobile as p } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as ge, Table as k, Skeleton as ye } from "antd";
import Ne from "../../BitzDrawer/index.mjs";
import pe from "../../BitzLoadMore/index.mjs";
import ve from "../../BitzPagination/index.mjs";
import me from "../../BitzNoData/index.mjs";
import we, { TableContext as Be } from "../Store/index.mjs";
import Ce from "../TableSkeleton/index.mjs";
import { columnSort as A, genColumnKey as V } from "../Store/utils/index.mjs";
import $ from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import ze from "../../../node_modules/lodash-es/at.mjs";
function ke({
  showPagination: g = !0,
  fillEvenRow: u = !0,
  evenRowBgColor: M = "#f9f9f9",
  height: y,
  dataSource: n = [],
  total: v = 0,
  columns: a,
  loading: c = !1,
  skeletonNum: R = 2,
  skeletonRender: T,
  skeletonRowNum: U = 4,
  skeletonRowsWidth: X = ["35%", "100%", "100%", "60%"],
  mobileLoadEmit: q = () => {
  },
  mobileRefreshEmit: F = () => {
  },
  operationFilter: m,
  enableControlPage: G,
  pagination: J,
  paginationEmit: Q = () => {
  },
  mobilePageHeight: W = 500,
  mobileCancelText: Y = "取消",
  noDataTitle: Z,
  noDataImg: I,
  color: S,
  size: L,
  showTableTool: ee = !0,
  tableAction: se,
  tableToolbar: ne,
  selectionBar: le,
  scroll: o,
  resetPage: re,
  ...h
}) {
  const { token: ie } = ge.useToken(), t = de(Be), [oe, w] = K(!1), te = d(() => (n == null ? void 0 : n.length) == v && (n == null ? void 0 : n.length) > 0, [n, v]), [xe, fe] = K([]), ae = (l, s) => {
    var i;
    const r = (i = m == null ? void 0 : m(l, s)) == null ? void 0 : i.filter(
      (f) => f.type !== "divider"
    );
    r != null && r.length && (fe(r), w(!0));
  }, E = () => {
    w(!1);
  }, he = (l) => {
    var s;
    w(!1), (s = l.onClick) == null || s.call(l);
  }, j = d(() => {
    const l = (r) => r.map((i) => {
      const f = V(
        (i == null ? void 0 : i.key) || (i == null ? void 0 : i.dataIndex),
        i.index
      ), x = t.columnsMap[f];
      return x && x.show === !1 ? !1 : i.children ? {
        ...i,
        children: l(i.children)
      } : i;
    }).filter(Boolean), s = l(a);
    return p ? s.sort(A(t.columnsMap)) : [
      k.SELECTION_COLUMN,
      k.EXPAND_COLUMN,
      ...s.sort(A(t.columnsMap))
    ];
  }, [t.columnsMap, a, p]);
  ce(() => {
    if (a && a.length > 0) {
      const l = a.map(
        (s) => (
          // @ts-ignore
          V((s == null ? void 0 : s.key) ?? (s == null ? void 0 : s.dataIndex), s == null ? void 0 : s.dataIndex)
        )
      );
      t.setSortKeyColumns(l);
    }
  }, [a]);
  const N = z(null), B = $(N), H = z(null), b = $(H), { y: C } = d(() => {
    if (typeof y > "u")
      return {};
    let l = 40, s = 40;
    if (N.current) {
      const x = window.getComputedStyle(N.current);
      l = parseInt(
        x.getPropertyValue("--cell-block") || "40"
      ), s = parseInt(
        x.getPropertyValue("--toolbar-height") || "40"
      );
    }
    const r = b == null ? void 0 : b.height;
    return { y: y - (r || 0) - s - l };
  }, [y, b == null ? void 0 : b.height, B == null ? void 0 : B.height]), be = z(null), O = d(() => o != null && o.x ? { x: o.x, y: o.y || C } : o != null && o.y ? n != null && n.length ? { x: 1e3, y: o.y } : { x: 1e3 } : n != null && n.length ? { x: 1e3, y: C } : { x: 1e3 }, [n, o, C]), P = d(() => `${L ?? (t == null ? void 0 : t.tableSize) ?? "lg"}BitzTable`, [L, t.tableSize]), _ = d(() => ({
    "--evenRow-BgColor": M
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    M
    /** token.Table?.borderColor */
  ]), D = je(
    (l, s) => u ? s % 2 === 0 ? "oddRow" : "evenRow" : "",
    [u]
  );
  return /* @__PURE__ */ e.jsxs("div", { className: "bitzTableBlock", children: [
    !p && /* @__PURE__ */ e.jsxs(
      "div",
      {
        ref: N,
        className: `bitzTableContainer ${P}`,
        style: { height: y },
        children: [
          /* @__PURE__ */ e.jsxs("div", { className: "bitzTableContainerBody", ref: be, children: [
            ee && /* @__PURE__ */ e.jsxs("div", { className: "bitzTableToolbarBlock", children: [
              se || /* @__PURE__ */ e.jsx("div", {}),
              ne,
              (h == null ? void 0 : h.rowSelection) && /* @__PURE__ */ e.jsx(e.Fragment, { children: le })
            ] }),
            c ? /* @__PURE__ */ e.jsx(
              Ce,
              {
                columns: j,
                dataLength: n == null ? void 0 : n.length,
                scroll: O,
                rowSelection: h.rowSelection,
                expandable: h.expandable,
                className: P,
                style: _,
                rowClassName: D
              }
            ) : /* @__PURE__ */ e.jsx(
              k,
              {
                columns: j,
                dataSource: n,
                loading: c,
                pagination: !1,
                scroll: O,
                ...h,
                style: _,
                rowClassName: D
              }
            )
          ] }),
          g && /* @__PURE__ */ e.jsx(
            ve,
            {
              ref: H,
              enableControl: G,
              pagination: J,
              total: v,
              dataSource: n,
              resetPage: re,
              paginationEmit: Q
            }
          )
        ]
      }
    ),
    p && /* @__PURE__ */ e.jsxs(e.Fragment, { children: [
      (c || (n == null ? void 0 : n.length) > 0) && /* @__PURE__ */ e.jsx(
        pe,
        {
          color: S,
          height: W,
          showNoMore: te,
          refreshEmit: F,
          loadEmit: q,
          extra: /* @__PURE__ */ e.jsxs("div", { className: "mobileTable", children: [
            n == null ? void 0 : n.map((l, s) => /* @__PURE__ */ e.jsxs("div", { onClick: () => ae(l, s), children: [
              /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: j == null ? void 0 : j.map((r, i) => {
                var f, x;
                return /* @__PURE__ */ e.jsx("div", { children: !(r != null && r.mobileHide) && /* @__PURE__ */ e.jsxs("div", { className: "row", children: [
                  /* @__PURE__ */ e.jsxs("div", { className: "label", children: [
                    r.title,
                    "："
                  ] }),
                  /* @__PURE__ */ e.jsx("div", { className: "value", children: ((f = r == null ? void 0 : r.render) == null ? void 0 : f.call(
                    r,
                    ze(l, r == null ? void 0 : r.dataIndex),
                    l,
                    s
                  )) || ((x = n[s]) == null ? void 0 : x[r.dataIndex]) })
                ] }) }, i);
              }) }),
              /* @__PURE__ */ e.jsx("div", { className: "rowBoxLine" })
            ] }, s)),
            c && Array.from({ length: R }).map((l, s) => /* @__PURE__ */ e.jsxs("div", { children: [
              /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: T ? T() : /* @__PURE__ */ e.jsx(
                ye,
                {
                  title: !1,
                  paragraph: {
                    rows: U,
                    width: X
                  },
                  active: !0
                }
              ) }),
              /* @__PURE__ */ e.jsx("div", { className: "rowBoxLine" })
            ] }, s)),
            /* @__PURE__ */ e.jsx(
              Ne,
              {
                className: "tableMobileDrawer",
                open: oe,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: E,
                children: /* @__PURE__ */ e.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ e.jsx("div", { className: "boxBody", children: xe.map((l, s) => /* @__PURE__ */ e.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => he(l),
                      ...l.danger && {
                        style: { color: ie.colorError }
                      },
                      children: l.label
                    },
                    s
                  )) }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxFooter", onClick: E, children: Y })
                ] })
              }
            )
          ] })
        }
      ),
      !c && /* @__PURE__ */ e.jsx(me, { data: n, title: Z, img: I })
    ] })
  ] });
}
const Re = (g) => (
  // @ts-ignore
  /* @__PURE__ */ e.jsx(we, { initValue: g, children: /* @__PURE__ */ e.jsx(ke, { ...g }) })
);
export {
  Re as default
};
